Index: trunk/src/opengl/glide/cvg/makefile
===================================================================
--- trunk/src/opengl/glide/cvg/makefile	(revision 3010)
+++ trunk/src/opengl/glide/cvg/makefile	(revision 3011)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 2000-03-01 14:26:49 sandervl Exp $
+# $Id: makefile,v 1.6 2000-03-04 20:03:43 bird Exp $
 #
 # PD-Win32 API
@@ -18,11 +18,11 @@
 CXXFLAGS = $(CXXFLAGS)  -I$(PDWIN32_INCLUDE)
 
-OBJS =	initterm.obj \
-	glideres.obj \
-	..\swlibs\pcilib\pcilib.lib \
-	texus\texus.lib \
-	init\init.lib \
+OBJS =  initterm.obj \
+        glideres.obj \
+        ..\swlibs\pcilib\pcilib.lib \
+        texus\texus.lib \
+        init\init.lib \
         glide\glide.lib \
- 
+
 all: ..\swlibs\pcilib\pcilib.lib init\init.lib texus\texus.lib glide\glide.lib $(TARGET).dll $(TARGET).lib
 
@@ -73,11 +73,11 @@
         *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h
     cd ..\swlibs\pcilib
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\..\cvg\glide
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\init
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\texus
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..
 
Index: trunk/src/opengl/glide/makefile
===================================================================
--- trunk/src/opengl/glide/makefile	(revision 3010)
+++ trunk/src/opengl/glide/makefile	(revision 3011)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.2 2000-02-25 00:39:57 sandervl Exp $
+# $Id: makefile,v 1.3 2000-03-04 20:03:42 bird Exp $
 #
 # PD-Win32 API
@@ -44,7 +44,7 @@
 dep:
     cd cvg
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\sst1
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..
 
Index: trunk/src/opengl/glide/sst1/init/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/init/makefile	(revision 3010)
+++ trunk/src/opengl/glide/sst1/init/makefile	(revision 3011)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.1 2000-02-25 00:31:27 sandervl Exp $
+# $Id: makefile,v 1.2 2000-03-04 20:03:43 bird Exp $
 #
 # PD-Win32 API
@@ -22,13 +22,13 @@
 CXXFLAGS = $(CXXFLAGS) $(CINCLUDE)
 
-OBJS =	H3DRVR.OBJ      INIT.OBJ        VG96DRVR.OBJ    VGDRVR.OBJ \
- 	$(TARGET2)\DAC.OBJ         $(TARGET2)\GAMMA.OBJ       $(TARGET2)\GDEBUG.OBJ      $(TARGET2)\INFO.OBJ        $(TARGET2)\PARSE.OBJ \
-	$(TARGET2)\PRINT.OBJ       $(TARGET2)\SLI.OBJ         $(TARGET2)\SST1INIT.OBJ    $(TARGET2)\UTIL.OBJ        $(TARGET2)\VIDEO.OBJ
+OBJS =  H3DRVR.OBJ      INIT.OBJ        VG96DRVR.OBJ    VGDRVR.OBJ \
+        $(TARGET2)\DAC.OBJ         $(TARGET2)\GAMMA.OBJ       $(TARGET2)\GDEBUG.OBJ      $(TARGET2)\INFO.OBJ        $(TARGET2)\PARSE.OBJ \
+        $(TARGET2)\PRINT.OBJ       $(TARGET2)\SLI.OBJ         $(TARGET2)\SST1INIT.OBJ    $(TARGET2)\UTIL.OBJ        $(TARGET2)\VIDEO.OBJ
 
 all: $(TARGET2).lib $(TARGET1).lib
 
 $(TARGET1).lib: $(OBJS)
-	$(RM) $(TARGET1).lib
-	$(ILIB) $(ILIBFLAGS) $(TARGET1).lib $(OBJS),,
+        $(RM) $(TARGET1).lib
+        $(ILIB) $(ILIBFLAGS) $(TARGET1).lib $(OBJS),,
 
 
@@ -41,7 +41,7 @@
     $(DEPEND) -I$(PDWIN32_INCLUDE);$(PDWIN32_INCLUDE)\win $(CINCLUDE) \
         *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h \
-        ..\incsrc\*.h ..\..\swlibs\fxmisc\*.h initvg\*.h ..\glide\*.h ..\texus\*.h ..\..\swlibs\pcilib\*.h 
+        ..\incsrc\*.h ..\..\swlibs\fxmisc\*.h initvg\*.h ..\glide\*.h ..\texus\*.h ..\..\swlibs\pcilib\*.h
     cd initvg
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
 
 !ifndef NODEP
Index: trunk/src/opengl/glide/sst1/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/makefile	(revision 3010)
+++ trunk/src/opengl/glide/sst1/makefile	(revision 3011)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.1 2000-02-25 00:31:07 sandervl Exp $
+# $Id: makefile,v 1.2 2000-03-04 20:03:43 bird Exp $
 #
 # PD-Win32 API
@@ -18,11 +18,11 @@
 CXXFLAGS = $(CXXFLAGS)  -I$(PDWIN32_INCLUDE)
 
-OBJS =	initterm.obj \
-	glideres.obj \
-	..\swlibs\pcilib\pcilib.lib \
-	texus\texus.lib \
-	init\init.lib \
+OBJS =  initterm.obj \
+        glideres.obj \
+        ..\swlibs\pcilib\pcilib.lib \
+        texus\texus.lib \
+        init\init.lib \
         glide\glide.lib \
- 
+
 all: ..\swlibs\pcilib\pcilib.lib init\init.lib texus\texus.lib glide\glide.lib $(TARGET).dll $(TARGET).lib
 
@@ -73,11 +73,11 @@
         *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h
     cd ..\swlibs\pcilib
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\..\sst1\glide
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\init
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\texus
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..
 
Index: trunk/src/opengl/makefile
===================================================================
--- trunk/src/opengl/makefile	(revision 3010)
+++ trunk/src/opengl/makefile	(revision 3011)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.14 2000-03-04 19:10:09 jeroen Exp $
+# $Id: makefile,v 1.15 2000-03-04 20:03:42 bird Exp $
 #
 # PD-Win32 API
@@ -130,13 +130,13 @@
         *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h
     cd glut
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\glu
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\glide
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\mesa
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd 3dfx
-    $(MAKE_CMD) NODEP=1 dep
+    $(MAKE_CMD) dep
     cd ..\..
 