Index: trunk/src/kernel32/makefile
===================================================================
--- trunk/src/kernel32/makefile	(revision 3016)
+++ trunk/src/kernel32/makefile	(revision 3019)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.86 2000-03-04 19:17:27 bird Exp $
+# $Id: makefile,v 1.87 2000-03-04 23:47:00 sandervl Exp $
 
 #
@@ -12,8 +12,11 @@
 PDWIN32_TOOLS = ..\..\tools\bin
 
+#SvL: Remove this when everything has been converted to the new build rules
+NEWBUILD=1
 
 !include $(PDWIN32_INCLUDE)/pdwin32.mk
 
-CFLAGS = $(CFLAGS) -I$(PDWIN32_INCLUDE)
+RESOURCES= kernelrsrc
+CFLAGS   = $(CFLAGS) -I$(PDWIN32_INCLUDE)
 CXXFLAGS = $(CXXFLAGS) -I$(PDWIN32_INCLUDE)
 
@@ -23,50 +26,112 @@
 !endif
 
-OBJS = KERNEL32.OBJ KOBJECTS.OBJ CONSOLE.OBJ CONIN.OBJ \
-CONBUFFER.OBJ CONOUT.OBJ UNICODE.OBJ network.OBJ HMDEVIO.OBJ \
-profile.obj THREAD.OBJ virtual.obj THUNK.OBJ OBSOLETE.OBJ COMM.OBJ\
-MESSAGE.OBJ RESOURCE.OBJ EXCEPTIONS.OBJ heapshared.obj cpuhlp.obj heapcode.obj \
-LFILE.OBJ NPIPE.OBJ oslibdos.obj oslibmisc.obj MISC.OBJ EXCEPTUTIL.OBJ \
-LANG.OBJ ICCIO.OBJ MAP.OBJ WIN32UTIL.OBJ heap.OBJ heapstring.obj \
-os2heap.OBJ vmutex.OBJ initterm.OBJ handlemanager.OBJ environ.obj initsystem.obj \
-hmdevice.obj hmopen32.obj hmobjects.obj hmevent.obj hmmutex.obj hmcomm.obj \
-hmsemaphore.obj wprocess.OBJ conprop.OBJ conprop2.obj winimagelx.obj \
-winimagebase.OBJ windllbase.OBJ winexebase.OBJ time.obj mmap.obj \
-winimagepe2lx.obj winimagepeldr.obj windllpe2lx.obj windlllx.obj windllpeldr.obj \
-winexepe2lx.obj winexelx.obj winexepeldr.obj WINRES.OBJ critsection.obj \
-pefile.OBJ winimgres.OBJ wintls.obj async.OBJ fileio.obj hmtoken.obj kernelrsrc.obj \
-atom.obj disk.obj directory.obj cvtbitmap.obj hmmmap.obj winfakepeldr.obj \
-cvtaccel.obj cvticon.obj cvticongrp.obj oslibexcept.obj cpu.obj process.obj \
-cvtcursor.obj cvtcursorgrp.obj stubs.obj interlock.obj toolhelp.obj codepage.obj \
-debug.obj oslibdebug.obj dbglocal.obj registry.obj
-
+OBJS = \
+$(OBJDIR)\KERNEL32.OBJ \
+$(OBJDIR)\KOBJECTS.OBJ \
+$(OBJDIR)\CONSOLE.OBJ \
+$(OBJDIR)\CONIN.OBJ \
+$(OBJDIR)\CONBUFFER.OBJ \
+$(OBJDIR)\CONOUT.OBJ \
+$(OBJDIR)\UNICODE.OBJ \
+$(OBJDIR)\network.OBJ \
+$(OBJDIR)\HMDEVIO.OBJ \
+$(OBJDIR)\profile.obj \
+$(OBJDIR)\THREAD.OBJ \
+$(OBJDIR)\virtual.obj \
+$(OBJDIR)\THUNK.OBJ \
+$(OBJDIR)\OBSOLETE.OBJ \
+$(OBJDIR)\COMM.OBJ \
+$(OBJDIR)\MESSAGE.OBJ \
+$(OBJDIR)\RESOURCE.OBJ \
+$(OBJDIR)\EXCEPTIONS.OBJ \
+$(OBJDIR)\heapshared.obj \
+$(OBJDIR)\cpuhlp.obj \
+$(OBJDIR)\heapcode.obj \
+$(OBJDIR)\LFILE.OBJ \
+$(OBJDIR)\NPIPE.OBJ \
+$(OBJDIR)\oslibdos.obj \
+$(OBJDIR)\oslibmisc.obj \
+$(OBJDIR)\MISC.OBJ \
+$(OBJDIR)\EXCEPTUTIL.OBJ \
+$(OBJDIR)\LANG.OBJ \
+$(OBJDIR)\ICCIO.OBJ \
+$(OBJDIR)\MAP.OBJ \
+$(OBJDIR)\WIN32UTIL.OBJ \
+$(OBJDIR)\heap.OBJ \
+$(OBJDIR)\heapstring.obj \
+$(OBJDIR)\os2heap.OBJ \
+$(OBJDIR)\vmutex.OBJ \
+$(OBJDIR)\initterm.OBJ \
+$(OBJDIR)\handlemanager.OBJ \
+$(OBJDIR)\environ.obj \
+$(OBJDIR)\initsystem.obj \
+$(OBJDIR)\hmdevice.obj \
+$(OBJDIR)\hmopen32.obj \
+$(OBJDIR)\hmobjects.obj \
+$(OBJDIR)\hmevent.obj \
+$(OBJDIR)\hmmutex.obj \
+$(OBJDIR)\hmcomm.obj \
+$(OBJDIR)\hmsemaphore.obj \
+$(OBJDIR)\wprocess.OBJ \
+$(OBJDIR)\conprop.OBJ \
+$(OBJDIR)\conprop2.obj \
+$(OBJDIR)\winimagelx.obj \
+$(OBJDIR)\winimagebase.OBJ \
+$(OBJDIR)\windllbase.OBJ \
+$(OBJDIR)\winexebase.OBJ \
+$(OBJDIR)\time.obj \
+$(OBJDIR)\mmap.obj \
+$(OBJDIR)\winimagepe2lx.obj \
+$(OBJDIR)\winimagepeldr.obj \
+$(OBJDIR)\windllpe2lx.obj \
+$(OBJDIR)\windlllx.obj \
+$(OBJDIR)\windllpeldr.obj \
+$(OBJDIR)\winexepe2lx.obj \
+$(OBJDIR)\winexelx.obj \
+$(OBJDIR)\winexepeldr.obj \
+$(OBJDIR)\WINRES.OBJ \
+$(OBJDIR)\critsection.obj \
+$(OBJDIR)\pefile.OBJ \
+$(OBJDIR)\winimgres.OBJ \
+$(OBJDIR)\wintls.obj \
+$(OBJDIR)\async.OBJ \
+$(OBJDIR)\fileio.obj \
+$(OBJDIR)\hmtoken.obj \
+$(OBJDIR)\$(RESOURCES).obj \
+$(OBJDIR)\atom.obj \
+$(OBJDIR)\disk.obj \
+$(OBJDIR)\directory.obj \
+$(OBJDIR)\cvtbitmap.obj \
+$(OBJDIR)\hmmmap.obj \
+$(OBJDIR)\winfakepeldr.obj \
+$(OBJDIR)\cvtaccel.obj \
+$(OBJDIR)\cvticon.obj \
+$(OBJDIR)\cvticongrp.obj \
+$(OBJDIR)\oslibexcept.obj \
+$(OBJDIR)\cpu.obj \
+$(OBJDIR)\process.obj \
+$(OBJDIR)\cvtcursor.obj \
+$(OBJDIR)\cvtcursorgrp.obj \
+$(OBJDIR)\stubs.obj \
+$(OBJDIR)\interlock.obj \
+$(OBJDIR)\toolhelp.obj \
+$(OBJDIR)\codepage.obj \
+$(OBJDIR)\debug.obj \
+$(OBJDIR)\oslibdebug.obj \
+$(OBJDIR)\dbglocal.obj \
+$(OBJDIR)\registry.obj
 
 TARGET = kernel32
 
-all: $(PDWIN32_LIB)\pmwinx.lib $(TARGET).dll $(TARGET).LIB
+all: $(OBJDIR) $(TARGET).dll $(TARGET).LIB
 
+$(TARGET).dll: $(OBJS) $(TARGET).def $(OBJDIR)\$(TARGET).lrf
+        $(LD2) $(LD2FLAGS) @$(OBJDIR)\$(TARGET).lrf
+        rc -r console.rc console.res
+        rc console.res $@
+        $(CP) $@ $(PDWIN32_BIN)
 
-$(TARGET).dll: $(OBJS) $(TARGET).def $(TARGET).lrf
-    $(LD2) $(LD2FLAGS) /NOFREE @$(TARGET).lrf
-    rc -r console.rc console.res
-    rc console.res $@
-    $(CP) $@ $(PDWIN32_BIN)
-
-# old linker stuff
-#   $(LD) $(LDFLAGS) /Fm /Fe$@ /B"/FREE" @$(TARGET).lrf
-#!ifdef DEBUG
-#!ifdef NODEBUGINFO
-#    ilink /nodeb /map /noe /NOD /NoLogo /NOFREE @$(TARGET).lrf
-#!else
-#    ilink /de /map  /noe /NOD /dbgpack /NoLogo /NOFREE @$(TARGET).lrf
-#!endif
-#!else
-#    ilink /map  /noe /NOD /NoLogo /NOFREE @$(TARGET).lrf
-#!endif
-
-
-
-$(TARGET).lrf: makefile
-        @echo Creating file <<$(@B).lrf
+$(OBJDIR)\$(TARGET).lrf: makefile
+        @echo Creating file <<$(OBJDIR)\$(@B).lrf
 $(OBJS)
 $(PDWIN32_LIB)\odincrt.lib
@@ -79,24 +144,8 @@
 <<keep
 
-
 lib: $(TARGET).lib $(PDWIN32_LIB)\$(TARGET).lib
 
-$(PDWIN32_LIB)\$(TARGET).lib: $(TARGET).lib
-    $(CP) $** $@
-
-$(TARGET).LIB: $(TARGET)exp.def
-    $(IMPLIB) $(IMPLIBFLAGS) $@ $(TARGET)exp.def
-    $(CP) $@ $(PDWIN32_LIB)
-
-$(TARGET)exp.def: $(TARGET).def
-    $(IMPDEF) $** $@
-
-
-$(PDWIN32_LIB)\pmwinx.lib:
-    $(IMPLIB) $(IMPLIBFLAGS) $@ $(PDWIN32_LIB)\pmwinx.def
-
-kernelrsrc.asm: kernel32.rc
-    $(RC) $(RCFLAGS) -o kernelrsrc.asm kernel32.rc
-
+$(RESOURCES).asm: kernel32.rc
+    $(RC) $(RCFLAGS) -o $(RESOURCES).asm kernel32.rc
 
 dep:
@@ -104,11 +153,3 @@
         *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h
 
-!ifndef NODEP
-!include .depend
-!endif
-
-
-clean:
-    $(RM) *.OBJ *.LIB *.dll *.lrf *.res *.map *.pch kernelrsrc.asm \
-        $(PDWIN32_LIB)\$(TARGET).LIB $(PDWIN32_BIN)\$(TARGET).dll \
-        $(TARGET)exp.def \
+!include $(PDWIN32_INCLUDE)/pdwin32.post
Index: trunk/src/user32/Makefile
===================================================================
--- trunk/src/user32/Makefile	(revision 3016)
+++ trunk/src/user32/Makefile	(revision 3019)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.66 2000-03-04 20:13:26 bird Exp $
+# $Id: Makefile,v 1.67 2000-03-04 23:47:19 sandervl Exp $
 
 #
@@ -12,8 +12,10 @@
 PDWIN32_TOOLS   = ..\..\tools\bin
 
+#SvL: Remove this when everything has been converted to the new build rules
+NEWBUILD=1
 
 !include $(PDWIN32_INCLUDE)/pdwin32.mk
 
-
+RESOURCES= resource
 CFLAGS   = $(CFLAGS)   -I$(PDWIN32_INCLUDE)
 CXXFLAGS = $(CXXFLAGS) -I$(PDWIN32_INCLUDE)
@@ -21,40 +23,82 @@
 TARGET = user32
 
-OBJS =  user32.obj loadres.obj \
-        dde.obj win32wndhandle.obj wsprintf.obj winmouse.obj \
-        icon.obj hook.obj winkeyboard.obj \
-        defwndproc.obj syscolor.obj char.obj initterm.obj \
-        uitools.obj unknown.obj spy.obj wndmsg.obj display.obj \
-        pmwindow.obj pmframe.obj win32class.obj win32wnd.obj win32dlg.obj \
-        msgbox.obj window.obj windowmsg.obj windowclass.obj win32wbase.obj \
-        windowword.obj gen_object.obj oslibwin.obj win32wndchild.obj \
-        controls.obj button.obj static.obj scroll.obj listbox.obj menu.obj\
-        combo.obj edit.obj winswitch.obj icontitle.obj clipboard.obj winicon.obj \
-        win32wmdiclient.obj oslibutil.obj oslibmsg.obj dib.obj oslibdos.obj \
-        win32wmdichild.obj winprop.obj wingdi.obj oslibgdi.obj winaccel.obj \
-        win32wbasepos.obj oslibres.obj dc.obj timer.obj dbglocal.obj \
-        caret.obj resource.obj winproc.obj text.obj oslibmsgtranslate.obj \
-        windlgmsg.obj windlg.obj win32wdesktop.obj win32wbasenonclient.obj
+OBJS = \
+$(OBJDIR)\user32.obj \
+$(OBJDIR)\loadres.obj \
+$(OBJDIR)\dde.obj \
+$(OBJDIR)\win32wndhandle.obj \
+$(OBJDIR)\wsprintf.obj \
+$(OBJDIR)\winmouse.obj \
+$(OBJDIR)\icon.obj \
+$(OBJDIR)\hook.obj \
+$(OBJDIR)\winkeyboard.obj \
+$(OBJDIR)\defwndproc.obj \
+$(OBJDIR)\syscolor.obj \
+$(OBJDIR)\char.obj \
+$(OBJDIR)\initterm.obj \
+$(OBJDIR)\uitools.obj \
+$(OBJDIR)\unknown.obj \
+$(OBJDIR)\spy.obj \
+$(OBJDIR)\wndmsg.obj \
+$(OBJDIR)\display.obj \
+$(OBJDIR)\pmwindow.obj \
+$(OBJDIR)\pmframe.obj \
+$(OBJDIR)\win32class.obj \
+$(OBJDIR)\win32wnd.obj \
+$(OBJDIR)\win32dlg.obj \
+$(OBJDIR)\msgbox.obj \
+$(OBJDIR)\window.obj \
+$(OBJDIR)\windowmsg.obj \
+$(OBJDIR)\windowclass.obj \
+$(OBJDIR)\win32wbase.obj \
+$(OBJDIR)\windowword.obj \
+$(OBJDIR)\gen_object.obj \
+$(OBJDIR)\oslibwin.obj \
+$(OBJDIR)\win32wndchild.obj \
+$(OBJDIR)\controls.obj \
+$(OBJDIR)\button.obj \
+$(OBJDIR)\static.obj \
+$(OBJDIR)\scroll.obj \
+$(OBJDIR)\listbox.obj \
+$(OBJDIR)\menu.obj \
+$(OBJDIR)\combo.obj \
+$(OBJDIR)\edit.obj \
+$(OBJDIR)\winswitch.obj \
+$(OBJDIR)\icontitle.obj \
+$(OBJDIR)\clipboard.obj \
+$(OBJDIR)\winicon.obj \
+$(OBJDIR)\win32wmdiclient.obj \
+$(OBJDIR)\oslibutil.obj \
+$(OBJDIR)\oslibmsg.obj \
+$(OBJDIR)\dib.obj \
+$(OBJDIR)\oslibdos.obj \
+$(OBJDIR)\win32wmdichild.obj \
+$(OBJDIR)\winprop.obj \
+$(OBJDIR)\wingdi.obj \
+$(OBJDIR)\oslibgdi.obj \
+$(OBJDIR)\winaccel.obj \
+$(OBJDIR)\win32wbasepos.obj \
+$(OBJDIR)\oslibres.obj \
+$(OBJDIR)\dc.obj \
+$(OBJDIR)\timer.obj \
+$(OBJDIR)\dbglocal.obj \
+$(OBJDIR)\caret.obj \
+$(OBJDIR)\$(RESOURCES).obj \
+$(OBJDIR)\winproc.obj \
+$(OBJDIR)\text.obj \
+$(OBJDIR)\oslibmsgtranslate.obj \
+$(OBJDIR)\windlgmsg.obj \
+$(OBJDIR)\windlg.obj \
+$(OBJDIR)\win32wdesktop.obj \
+$(OBJDIR)\win32wbasenonclient.obj
 
+all: $(OBJDIR) $(TARGET).dll $(TARGET).lib
 
-all: $(TARGET).dll $(TARGET).lib
-
-
-$(TARGET).dll: $(OBJS) $(TARGET).def $(TARGET).lrf
-        $(LD2) $(LD2FLAGS) @$(TARGET).lrf
+$(TARGET).dll: $(OBJS) $(TARGET).def $(OBJDIR)\$(TARGET).lrf
+        $(LD2) $(LD2FLAGS) @$(OBJDIR)\$(TARGET).lrf
         $(CP) $@ $(PDWIN32_BIN)
 
-#!ifdef DEBUG
-#!ifdef NODEBUGINFO
-#        ilink /nodeb /map /noe /NOD /NoLogo /NOFREE @$(TARGET).lrf
-#!else
-#        ilink /de /map  /noe /NOD /dbgpack /NoLogo /NOFREE @$(TARGET).lrf
-#!endif
-#!else
-#        ilink /map  /noe /NOD /NoLogo /FREE @$(TARGET).lrf
-#!endif
-
-$(TARGET).lrf: makefile
-        @echo Creating file <<$(@B).lrf
+$(OBJDIR)\$(TARGET).lrf: makefile
+        @echo Creating file <<$(OBJDIR)\$(@B).lrf
 $(OBJS)
 $(PDWIN32_LIB)/pmwinx.lib
@@ -71,18 +115,7 @@
 lib: $(TARGET).lib $(PDWIN32_LIB)\$(TARGET).lib
 
-$(PDWIN32_LIB)\$(TARGET).lib: $(TARGET).lib
-    $(CP) $** $@
 
-$(TARGET).lib: $(TARGET)exp.def
-    $(IMPLIB) $(IMPLIBFLAGS) $@ $(TARGET)exp.def
-    $(CP) $@ $(PDWIN32_LIB)
-
-$(TARGET)exp.def: $(TARGET).def
-    $(IMPDEF) $** $@
-
-
-resource.asm: user32.rc
-    $(RC) $(RCFLAGS) -o resource.asm user32.rc
-
+$(RESOURCES).asm: user32.rc
+    $(RC) $(RCFLAGS) -o $(RESOURCES).asm user32.rc
 
 dep:
@@ -90,12 +123,4 @@
         *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h
 
-!ifndef NODEP
-!include .depend
-!endif
+!include $(PDWIN32_INCLUDE)/pdwin32.post
 
-
-clean:
-    $(RM) *.obj *.lib *.dll *.map *.pch *.res *.lrf resource.asm *.lrf \
-        $(PDWIN32_BIN)\$(TARGET).dll $(PDWIN32_LIB)\$(TARGET).lib \
-        $(TARGET)exp.def
-